package com.diaoyun.zion.chinafrica.bis.impl;

import com.diaoyun.zion.chinafrica.bis.IItemSpider;
import com.diaoyun.zion.chinafrica.enums.PlatformEnum;
import com.diaoyun.zion.chinafrica.vo.ProductResponse;
import com.diaoyun.zion.master.util.HttpClientUtil;
import com.diaoyun.zion.master.util.JsoupUtil;
import com.diaoyun.zion.master.util.SpiderUtil;
import com.diaoyun.zion.master.util.TranslateHelper;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.net.URISyntaxException;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;

/**
 * Zara西班牙时尚品牌数据爬虫
 *
 * @author 爱酱油不爱醋
 */
@Component("zaraSpider")
public class ZaraSpider implements IItemSpider {
    private static Logger logger = LoggerFactory.getLogger(ZaraSpider.class);

    //西班牙时尚品牌数据爬虫
    private static final String zaraUrl = "https://www.zara.cn/cn/zh/";

    @Override
    public JSONObject captureItem(String targetUrl) throws URISyntaxException, IOException, ExecutionException, InterruptedException, TimeoutException {
        JSONObject resultObj;
        // 获取url中的网页内容
        String content = HttpClientUtil.getContentByUrl(targetUrl, PlatformEnum.ZARA.getValue());
        // 截取主要的 Json 内容
        resultObj = JsoupUtil.getZaraJsonData(content);
        // 按照封装规范封装商品数据
        ProductResponse productResponse = SpiderUtil.formatZaraProductResponse(resultObj);
        // 将封装数据转换为 json 数据
        resultObj = JSONObject.fromObject(productResponse);
        // 翻译
        TranslateHelper.translateProductResponse(resultObj);
        return resultObj;
    }

}
